package com.yihu.hos.services;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.mongodb.*;
import com.yihu.hos.core.datatype.DateUtil;
import com.yihu.hos.core.datatype.NumberUtil;
import com.yihu.hos.core.datatype.StringUtil;
import com.yihu.hos.models.BusinessLog;
import com.yihu.hos.models.ServiceMetrics;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.*;

/**
 * Created by chenweida on 2016/1/27.
 */
@Service("ServiceMonitorService")
public class ServiceMonitorService {
    public static final String BEAN_ID = "ServiceMonitorService";
    @Autowired
    private MongoOperations mongoOperations;
    private DBCollection businessLog;
//    public Result mapReduce(String beginTime, String endTime) {
//        DBCollection businessLogDB = mongoOperations.getCollection(mongoOperations
//                .getCollectionName(BusinessLog.class));
//
//        String map = "function(){emit(this.breadcrumbId, this.fireTime);}";
//        String reduce = "function(key, values){ return values[0];}";
//        String out = reduceTableName;
//        BasicDBObject queryObject = new BasicDBObject().append(QueryOperators.AND,
//                new BasicDBObject[]{
//                        new BasicDBObject().append("fireTime",
//                            new BasicDBObject().append(QueryOperators.GTE, DateUtil.toTimestamp(beginTime))),
//                        new BasicDBObject().append("fireTime",
//                                new BasicDBObject().append(QueryOperators.LT, DateUtil.toTimestamp(endTime)))});
//
//        MapReduceOutput mapReduceOutput = businessLogDB.mapReduce(map,
//                reduce.toString(), out, queryObject);
//        DBCollection resultColl = mapReduceOutput.getOutputCollection();
//        DBCursor cursor = resultColl.find();
//        String result = "";
//
//        while (cursor.hasNext()) {
//            result += cursor.next();
//        }
//        return Result.success(result);
//    }
//
//    public JSONObject aggregate(String beginTime, String endTime) {
//        DBCollection reduceDB = mongoOperations.getCollection(mongoOperations
//                .getCollectionName(ReduceResult.class));
//        BasicDBObject queryObject = new BasicDBObject().append(QueryOperators.AND,
//                new BasicDBObject[]{
//                        new BasicDBObject().append("value",
//                                new BasicDBObject().append(QueryOperators.GTE, DateUtil.toTimestamp(beginTime))),
//                        new BasicDBObject().append("value",
//                                new BasicDBObject().append(QueryOperators.LT, DateUtil.toTimestamp(endTime)))});
//
//        DBObject match = new BasicDBObject("$match", queryObject);
//
//        // Now the $group operation
//        DBObject groupFields = new BasicDBObject( "_id", new BasicDBObject("$minute", "$value"));
//        groupFields.put("pv", new BasicDBObject( "$sum", 1));
//        DBObject group = new BasicDBObject("$group", groupFields);
//
//        // build the $sort operation
//        DBObject sortFields =  new BasicDBObject( "_id", 1);
//        DBObject sort = new BasicDBObject("$sort", sortFields );
//        // run aggregation
//        AggregationOutput output = reduceDB.aggregate(match, group, sort);
//        String result = "";
//        for (DBObject dbObject : output.results()) {
//            result += dbObject.toString();
//        }
//        JSONObject jsonObject = new JSONObject(result);
//        return jsonObject;
//    }

    public DBCollection getBusinessLog() {
        if (businessLog == null) {
            businessLog = mongoOperations.getCollection(mongoOperations
                    .getCollectionName(BusinessLog.class));
        }
        return businessLog;

    }
    public void bandwidth(String beginTime, String endTime) {

        DBObject match = getMatchFields(beginTime, endTime);
        DBObject flowGroup = getFlowGroupFields();
        DBObject sort = getSortFields();
        DBObject serviceGroup = getServiceGroupFields();
        // run aggregation
        AggregationOutput flowOutput = getBusinessLog().aggregate(match, flowGroup, sort);
        // run aggregation
        AggregationOutput serviceOutput = getBusinessLog().aggregate(match, serviceGroup, sort);
        //流程带宽
        Integer flowCalls = 0;
        String routeId = "";
        for (DBObject dbObject : flowOutput.results()) {
            Integer count = Integer.parseInt(StringUtil.toString(dbObject.get("count")));
            BasicDBObject id = (BasicDBObject) dbObject.get("_id");
            routeId = StringUtil.toString(id.get("routeId"));
            if (count >= 2) {
                flowCalls++;
            }
        }
        long interval = getInterval(beginTime, endTime);
        BigDecimal flowBandwidth = NumberUtil.divideBigDecimal(BigDecimal.valueOf(flowCalls), BigDecimal.valueOf(interval));
        saveServiceMetrics(routeId, "bandwidth", flowBandwidth.toString(), endTime);
        //服务带宽
        Integer serviceCalls = 0;
        String code = "";
        for (DBObject dbObject : serviceOutput.results()) {
            BasicDBObject id = (BasicDBObject) dbObject.get("_id");
            code = StringUtil.toString(id.get("code"));
            serviceCalls++;
        }
        serviceCalls = serviceCalls/2;
        BigDecimal serviceBandwidth = NumberUtil.divideBigDecimal(BigDecimal.valueOf(serviceCalls), BigDecimal.valueOf(interval));
        saveServiceMetrics(code, "bandwidth", serviceBandwidth.toString(), endTime);
    }


    public void qps(String beginTime, String endTime) {
        DBObject match = getMatchFields(beginTime, endTime);
        DBObject flowGroup = getFlowGroupFields();
        DBObject sort = getSortFields();
        DBObject serviceGroup = getServiceGroupFields();
        // run aggregation
        AggregationOutput flowOutput = getBusinessLog().aggregate(match, flowGroup, sort);
        // run aggregation
        AggregationOutput serviceOutput = getBusinessLog().aggregate(match, serviceGroup, sort);

        //流程qps
        Integer flowCalls = 0;
        String routeId = "";
        for (DBObject dbObject : flowOutput.results()) {
            Integer count = Integer.parseInt(StringUtil.toString(dbObject.get("count")));
            BasicDBObject id = (BasicDBObject) dbObject.get("_id");
            routeId = StringUtil.toString(id.get("routeId"));
            if (count >= 2) {
                Integer total = Integer.parseInt(StringUtil.toString(dbObject.get("total")));
                if (total == count/2) {
                    flowCalls++;
                }
            }
        }


        long interval = getInterval(beginTime, endTime);
        BigDecimal flowQps = NumberUtil.divideBigDecimal(BigDecimal.valueOf(flowCalls), BigDecimal.valueOf(interval));
        saveServiceMetrics(routeId, "qps", flowQps.toString(), endTime);
        //服务带宽
        Integer serviceCalls = 0;
        String code = "";
        for (DBObject dbObject : serviceOutput.results()) {
            BasicDBObject id = (BasicDBObject) dbObject.get("_id");
            code = StringUtil.toString(id.get("code"));
            serviceCalls++;
        }
        serviceCalls = serviceCalls/2;
        BigDecimal serviceQps = NumberUtil.divideBigDecimal(BigDecimal.valueOf(serviceCalls), BigDecimal.valueOf(interval));
        saveServiceMetrics(code, "bandwidth", serviceQps.toString(), endTime);
    }

    public void usage(String beginTime, String endTime) throws JsonProcessingException {
        DBObject match = getMatchFields(beginTime, endTime);
        DBObject flowGroup = getFlowGroupFields();
        DBObject sort = getSortFields();
        // run aggregation
        AggregationOutput flowOutput = getBusinessLog().aggregate(match, flowGroup, sort);
        Integer successCountF = 0;
        Integer failureCountF = 0;
        String routeId = "";
        for (DBObject dbObject : flowOutput.results()) {
            Integer total = Integer.parseInt(StringUtil.toString(dbObject.get("total")));
            Integer count = Integer.parseInt(StringUtil.toString(dbObject.get("count")));
            BasicDBObject id = (BasicDBObject) dbObject.get("_id");
            routeId = StringUtil.toString(id.get("routeId"));
            if (total == count) {
                successCountF++;
            } else {
                failureCountF++;
            }
        }
        ObjectMapper objectMapper = new ObjectMapper();

        JSONObject resultF = new JSONObject();
        resultF.put("totalCount", successCountF + failureCountF);
        resultF.put("successCount", successCountF);
        resultF.put("failureCount", failureCountF);
        saveServiceMetrics(routeId, "usage", objectMapper.writeValueAsString(resultF.toString()), endTime);

        DBCursor serviceOutput = getBusinessLog().find(getQueryObject(beginTime, endTime));

        Map<String, Integer> usageMap = new HashMap<>();
        Map<String, Integer> usageFailMap = new HashMap<>();
        Map<String, DBObject> serviceMap = new HashMap<>();
        for (DBObject dbObject : serviceOutput.toArray()) {
            String code = StringUtil.toString(dbObject.get("code"));
            if (!usageMap.containsKey(code)) {
                usageMap.put(code, 0);
            }
            if (serviceMap.containsKey(code)) {

                serviceMap.remove(code);
                Integer usageTemp = usageMap.get(code);
                usageMap.put(code, ++usageTemp);
                usageFailMap.put(code, 0);
            } else {
                serviceMap.put(code, dbObject);
                Integer usageTemp = usageMap.get(code);
                usageFailMap.put(code, ++usageTemp);
            }
        }

        for (String code : usageMap.keySet()) {
            JSONObject resultS = new JSONObject();
            resultS.put("totalCount", usageMap.get(code) + usageFailMap.get(code));
            resultS.put("successCount", usageMap.get(code));
            resultS.put("failureCount", usageFailMap.get(code));
            saveServiceMetrics(code, "usage", objectMapper.writeValueAsString(resultS.toString()), endTime);

        }
    }

    public void delay(String beginTime, String endTime) {
        DBObject match = getMatchFields(beginTime, endTime);
        DBObject flowGroup = getFlowGroupFields();
        DBObject sort = getSortFields();
        // run aggregation
        AggregationOutput flowOutput = getBusinessLog().aggregate(match, flowGroup, sort);


        BigDecimal flowDelay = BigDecimal.ZERO;
        String routeId = "";
        for (DBObject dbObject : flowOutput.results()) {
            Integer count = Integer.parseInt(StringUtil.toString(dbObject.get("count")));
            BasicDBObject id = (BasicDBObject) dbObject.get("_id");
            routeId = StringUtil.toString(id.get("routeId"));
            if (count >= 2) {
                String begin = StringUtil.toString(dbObject.get("beginTime"));
                String end = StringUtil.toString(dbObject.get("endTime"));
                long interval = getIntervalExact(begin, end);
                flowDelay = flowDelay.add(BigDecimal.valueOf(interval));
            }
        }
        saveServiceMetrics(routeId, "delay", flowDelay.toString(), endTime);


        DBCursor serviceOutput = getBusinessLog().find(getQueryObject(beginTime, endTime));

        Map<String, BigDecimal> delayMap = new HashMap<>();
        Map<String, DBObject> serviceMap = new HashMap<>();
        for (DBObject dbObject : serviceOutput.toArray()) {
            String code = StringUtil.toString(dbObject.get("code"));
            if (serviceMap.containsKey(code)) {
                DBObject dbObjectTemp = serviceMap.remove(code);
                String begin = StringUtil.toString(dbObjectTemp.get("fireTime"));
                String end = StringUtil.toString(dbObject.get("fireTime"));
                long interval = getIntervalExact(begin, end);
                if (delayMap.containsKey(code)) {
                    BigDecimal delayTemp = delayMap.get(code);
                    delayMap.put(code, delayTemp.add(BigDecimal.valueOf(interval)));
                } else {
                    delayMap.put(code, BigDecimal.valueOf(interval));
                }
            } else {
                serviceMap.put(code, dbObject);
            }
        }
        for (String code : delayMap.keySet()) {
            saveServiceMetrics(code, "delay", delayMap.get(code).toString(), endTime);
        }
    }

    public DBObject getMatchFields(String beginTime, String endTime) {
        return new BasicDBObject("$match", getQueryObject(beginTime, endTime));
    }

    public DBObject getQueryObject(String beginTime, String endTime) {
        BasicDBObject queryObject = new BasicDBObject().append(QueryOperators.AND,
                new BasicDBObject[]{
                        new BasicDBObject().append("fireTime",
                                new BasicDBObject().append(QueryOperators.GTE, DateUtil.toTimestamp(beginTime))),
                        new BasicDBObject().append("fireTime",
                                new BasicDBObject().append(QueryOperators.LT, DateUtil.toTimestamp(endTime)))});

        return queryObject;
    }


    public DBObject getServiceGroupFields() {

        // Now the $group operation
        DBObject groupFields = new BasicDBObject( "_id",
                new BasicDBObject("id", "$_id")
                        .append("code", "$code"));
        groupFields.put("count", new BasicDBObject( "$sum", 1));
        groupFields.put("total", new BasicDBObject( "$first", "$totalServers"));
        return new BasicDBObject("$group", groupFields);
    }

    public DBObject getFlowGroupFields() {

        // Now the $group operation
        DBObject groupFields = new BasicDBObject( "_id",
                new BasicDBObject("breadcrumbId", "$breadcrumbId")
                        .append("routeId", "$routeId"));
        groupFields.put("count", new BasicDBObject( "$sum", 1));
        groupFields.put("total", new BasicDBObject( "$first", "$totalServers"));
        groupFields.put("beginTime", new BasicDBObject( "$first", "$fireTimeSource"));
        groupFields.put("endTime", new BasicDBObject("$last", "$fireTimeSource"));

        return new BasicDBObject("$group", groupFields);
    }

    public DBObject getSortFields() {
        DBObject sortFields =  new BasicDBObject( "_id", 1);
        return new BasicDBObject("$sort", sortFields );
    }

    public long getInterval(String beginTime, String endTime) {
        Date from = DateUtil.toTimestamp(beginTime, DateUtil.DEFAULT_YMDHMSDATE_FORMAT);
        Date to = DateUtil.toTimestamp(endTime, DateUtil.DEFAULT_YMDHMSDATE_FORMAT);
        long interval = (to.getTime() - from.getTime())/1000;
        return interval;
    }

    public long getIntervalExact(String beginTime, String endTime) {
        Date from = DateUtil.toTimestamp(beginTime, DateUtil.DEFAULT_TIMESTAMP_FORMAT);
        Date to = DateUtil.toTimestamp(endTime, DateUtil.DEFAULT_TIMESTAMP_FORMAT);
        long interval = (to.getTime() - from.getTime())/1000;
        return interval;
    }

    public void saveServiceMetrics(String name, String type, String value, String createTime) {
        ServiceMetrics serviceMetrics = new ServiceMetrics();
        serviceMetrics.setName(name);
        serviceMetrics.setType(type);
        serviceMetrics.setValue(value);
        serviceMetrics.setCreateTime(createTime);
        mongoOperations.save(serviceMetrics);
    }
}
