package com.yihu.hos.monitor.controller;

import com.yihu.hos.core.datatype.DateUtil;
import com.yihu.hos.monitor.service.ServiceMonitorService;
import com.yihu.hos.web.framework.model.Result;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;
import java.util.Date;

/**
 * @author HZY
 * @vsrsion 1.0
 * Created at 2016/10/26.
 */
@Controller("ServiceMonitorController")
@RequestMapping("/monitor/service")
public class ServiceMonitorController {

    @Resource(name = ServiceMonitorService.BEAN_ID)
    private ServiceMonitorService monitorService;


    //跳转到列表页
    @RequestMapping("/initial")
    public String serviceInitial(Model model) {
        model.addAttribute("contentPage", "/monitor/service/sEnvManage");
        return "partView";
    }


    @RequestMapping(value = "/metrics", method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "获取服务指标", produces = "application/json", notes = "获取服务指标")
    public Result metrics(
            @ApiParam(name = "id", value = "serviceID", required = true)
            @RequestParam(value = "id") String id) {
        Date now = new Date();
        Date beforeDate = new Date(now.getTime() - 3600000);
        String beginTime = DateUtil.toString(beforeDate, DateUtil.DEFAULT_YMDHMSDATE_FORMAT);
        String endTime = DateUtil.toString(now, DateUtil.DEFAULT_YMDHMSDATE_FORMAT);
        try {
            return monitorService.metrics(id, beginTime, endTime);
        } catch (Exception e) {
            return Result.error("获取服务指标失败");
        }
    }

    @RequestMapping(value = "/trees", method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "获取服务树列表", produces = "application/json", notes = "获取服务树列表")
    public Result trees() {
        try {
            return monitorService.getServiceTreeList();
        } catch (Exception e) {
            return Result.error("获取服务树列表失败");
        }
    }
}
