<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="utf-8" %>
<%@include file="/WEB-INF/ehr/commons/jsp/commonInclude.jsp" %>
<script src="${contextRoot}/develop/lib/plugin/echarts/echarts-all.js"></script>
<script>

    $(function () {
        //l-layout-left
        //初始化layout
        $("#div_wrapper").ligerLayout({
            height: "99%",
            leftWidth: 200,
            isLeftCollapse: false,//左边区域初始化不可以隐藏
            allowLeftCollapse: false//左边区域不可以隐藏
        });
        //初始化树
        getServiceTree();
    });

    function getServiceTree(){
        var serviceTree = $("#div_wrapper_left_ul_servicetree");
        //初始化树
        $.ajax({
            type: "GET",
            url: "${contextRoot}/monitor/service/trees",
            success: function (msg) {
                if (msg.successFlg) {
                    // 初始化树形菜单
                    var message = JSON.parse(msg.message);
                    serviceTree = serviceTree.ligerTree({
                        data: message,
                        idFieldName: 'id',
                        nodeWidth: 200,
                        parentIDFieldName: 'pid',
                        isExpand: false,
                        onClick: function (obj) {
                            //初始化图表
                            debugger;
                             getServiceInfo(obj.data.id);
                        },
                        onSuccess: function (data) {

                        }
                    });
                    getServiceInfo(message[0].id);
                }
            }
        });
    }

    function getServiceInfo(id){
        $.ajax({
            type: "GET",
            url : "${contextRoot}/monitor/service/metrics",
            dataType : "json",
            data:{id:id},
            cache:false,
            success :function(re){
                debugger;
                if(re.successFlg) {
                    //TODO 设置图表
                    var message = JSON.parse(re.message);
                    var serviceInfo = message.serviceInfo;
                    $("#serviceName").text(serviceInfo.name);
                    $("#serviceDescription").text(serviceInfo.description);

                    service.bandwidth(message.bandwidth);
                    service.qps(message.qps);
                    service.delay(message.delay);
                    service.usage(message.usage);
                } else {
                    $.ligerDialog.error(re.message);
                }
            },
            error :function(data){
                $.ligerDialog.error("Status:"+data.status +"(" +data.statusText+")");
            }
        });
    }

    var service = {
        bandwidth:function(data){
            // 基于准备好的dom，初始化echarts实例
            var myChart = echarts.init(document.getElementById('main1'));
             if(data!=null && data.length>0)
             {
                 var x = [];
                 var y = [];
                 for(var i=0;i<data.length;i++)
                 {
                     var createTime = data[i].createTime.substring(11,16);
                     x.push(createTime);
                     y.push(data[i].value);
                 }
                 // 指定图表的配置项和数据
                 var option = {
                     title: {
                         text: ' 带宽',
                         left: 'center'
                     },
                     tooltip: {
                         trigger: 'axis'
                     },
                     legend: {
                         left: 'left',
                         data: ['使用率']
                     },
                     xAxis: {
                         type: 'category',
                         name: '时间',
                         splitLine: {show: false},
                         data: x
                     },
                     grid: {
                         left: '3%',
                         right: '4%',
                         bottom: '3%',
                         containLabel: true
                     },
                     yAxis: {
                         type: 'log',
                         name: '使用率'
                     },
                     series: [
                         {
                             name: '使用率',
                             type: 'line',
                             data: y
                         },
                     ]
                 };
             myChart.setOption(option);
             //设置图例下方的信息
             } else{
                 myChart.clear();
             }
        },
        qps:function(data){
            // 基于准备好的dom，初始化echarts实例
            var myChart = echarts.init(document.getElementById('main2'));
            if(data!=null && data.length>0)
            {
                var x = [];
                var y = [];
                for(var i=0;i<data.length;i++)
                {
                    var createTime = data[i].createTime.substring(11,16);
                    x.push(createTime);
                    y.push(data[i].value);
                }
                // 指定图表的配置项和数据
                var option = {
                    title: {
                        text: ' 吞吐量',
                        left: 'center'
                    },
                    tooltip: {
                        trigger: 'axis'
                    },
                    legend: {
                        left: 'left',
                        data: ['使用率']
                    },
                    xAxis: {
                        type: 'category',
                        name: '时间',
                        splitLine: {show: false},
                        data: x
                    },
                    grid: {
                        left: '3%',
                        right: '4%',
                        bottom: '3%',
                        containLabel: true
                    },
                    yAxis: {
                        type: 'log',
                        name: '使用率'
                    },
                    series: [
                        {
                            name: '使用率',
                            type: 'line',
                            data: y
                        },
                    ]
                };
                myChart.setOption(option);
            }
            else{
                myChart.clear();
            }
        },
        delay:function(data){
            // 基于准备好的dom，初始化echarts实例
            var myChart = echarts.init(document.getElementById('main3'));
            if(data!=null && data.length>0)
            {
                var x = [];
                var y = [];
                for(var i=0;i<data.length;i++)
                {
                    var createTime = data[i].createTime.substring(11,16);
                    x.push(createTime);
                    y.push(data[i].value);
                }
                // 指定图表的配置项和数据
                var option = {
                    title: {
                        text: ' 延时',
                        left: 'center'
                    },
                    tooltip: {
                        trigger: 'axis'
                    },
                    legend: {
                        left: 'left',
                        data: ['已使用']
                    },
                    xAxis: {
                        type: 'category',
                        name: '时间',
                        splitLine: {show: false},
                        data: x
                    },
                    grid: {
                        left: '3%',
                        right: '4%',
                        bottom: '3%',
                        containLabel: true
                    },
                    yAxis: {
                        type: 'log',
                        name: '使用率'
                    },
                    series: [
                        {
                            name: '已使用',
                            type: 'line',
                            data: y
                        }
                    ]
                };
                myChart.setOption(option);
            }
            else{
                myChart.clear();
            }
        },
        usage:function(data){
            // 基于准备好的dom，初始化echarts实例
            var myChart = echarts.init(document.getElementById('main4'));
            debugger;
            if(data!=null && data.length>0)
            {
                var x = [];
                var y1 = [];
                var y2 = [];
                var y3 = [];
                for(var i=0;i<data.length;i++)
                {
                    var createTime = data[i].createTime.substring(11,16);
                    x.push(createTime);
                    var count = JSON.parse(JSON.parse(data[i].value));
                    y1.push(count.totalCount);
                    y2.push(count.successCount);
                    y3.push(count.failureCount);
                }
                // 指定图表的配置项和数据

                var option = {
                    title: {
                        text: ' 使用率',
                        left: 'center'
                    },
                    tooltip: {
                        trigger: 'axis'
                    },
                    legend: {
                        left: 'left',
                        data: ['总使用数', '成功数', '失败数']
                    },
                        xAxis: {
                        type: 'category',
                        name: '时间',
                        splitLine: {show: false},
                        data: x
                    },
                    grid: {
                        left: '3%',
                        right: '4%',
                        bottom: '3%',
                        containLabel: true
                    },
                    yAxis: {
                        type: 'log',
                        name: '使用数'
                    },
                    series: [
                        {
                            name: '总使用数',
                            type: 'line',
                            data: y1
                        },
                        {
                            name: '成功数',
                            type: 'line',
                            data: y2
                        },
                        {
                            name: '失败数',
                            type: 'line',
                            data: y3
                        }
                    ]
                };
                myChart.setOption(option);
            }
            else{
                myChart.clear();
            }
        }
    };


    /*当前时间*/
    function nowDate(){
        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var day = date.getDate();
        var hour = date.getHours();
        var minute = date.getMinutes();
        var second = date.getSeconds();
        return year + '-' + month + '-' + day  + ' ' + hour + ':' + minute + ':' + second;
    }
    /*前一天时间*/
    function prevDate(){
        var now = new Date();
        var date = new Date(now.getTime() -  24 * 3600 * 1000);
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var day = date.getDate();
        return year + '-' + month + '-' + day  + ' 00:00:00';
    }

</script>